// prepreka
// nit 0 povečuje spremenljivko shared, izpis za prepreko naj bi bil pri vseh nitih enak
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	4
#define NPRINTS		5

int shared;

void* barrier(void* arg)
{
	int i;
	int myid = (int)arg;

	for (i = 0; i<NPRINTS; i++)
	{
		if (myid == 0)
			shared++;

		// prepreka

		printf("Nit %d: vrednost: %d\n", myid, shared);
	}

	return NULL;
}

int main(int argc, char *argv[])
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;

	for (i = 0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for (i = 0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	return 0;
}
